/*********************************************************************
*
*                          memo.c
*
*  Copyright (c) 1992, John N. Sanders, Massachusetts Institute of
*      Technology, Lincoln Laboratory; 244 Wood Street, Lexington,
*      MA 02173.
*  All Rights Reserved.
*  Version 1.0   4/93
*
**********************************************************************
*/
#include "stdio.h"
#include "string.h"

#include "X11/Intrinsic.h"
#include "X11/Shell.h"
#include "Xm/Xm.h"
#include "Xm/Label.h"

void memo_exit();

XmStringCharSet CharSet = (XmStringCharSet) XmSTRING_DEFAULT_CHARSET;

main(argc, argv)
     int
       argc;
     char
       *argv[];
{
  int
    i,
    nargs;
  char
    filename[80],
    font_name[80],
    msg_buf[500],
    buf[80];
  FILE
    *fp;
  XtAppContext
    theAppContext;
  Display
    *display;
  Arg
    args[10];
  XFontStruct
    *font_struct;
  XmFontList
    font_list;
  XmString
    message;
  Widget
    app_shell,
    main_label;

/*******************************/
XtToolkitInitialize();
theAppContext = XtCreateApplicationContext();
display = XtOpenDisplay(theAppContext, NULL, argv[0], "memo",
			NULL, 0, (Cardinal *) &argc, argv);
if (display == NULL)
  {
    fprintf(stderr, "Unable to open requested display. Aborting\n");
    exit(1);
  }
app_shell = XtAppCreateShell("Memo", "memclass",
			    applicationShellWidgetClass, display, NULL, 0);

#ifdef JUNK
/******* a useful bit of debugging code ********/
  {
    char **rtrn;
    char dir0[80], dir1[80], dir2[80], *chrptr[5];
    int i, actual;

    i = 0;
    rtrn = &chrptr[0];
    chrptr[0] = &dir0[0];
    chrptr[1] = &dir1[0];
    strcpy(dir0, "/usr/lib/X11/fonts/misc");
    strcpy(dir1, "/usr/lib/X11/fonts");
    printf("dirs: %s %s %s\n", chrptr[0], chrptr[1], chrptr[2]);
    XSetFontPath(display, &chrptr, i);
    printf("set font path\n");

    rtrn = XListFonts(display, "6x*", 100, &actual);
    printf("acutal = %d\n", actual);
    for (i=0; i<actual; ++i)
      printf("  **%s**\n", rtrn[i]);
    printf("*** finished ***\n");
    exit(0);
  }
#endif

/******* fonts ********/
strcpy(font_name, "helvB36.iso1");
if (argc > 2)
  strcpy(font_name, argv[2]);
font_struct = XLoadQueryFont(display, font_name);
if (font_struct == NULL)
  {
    fprintf(stderr, "ERROR: Unable to find font %s. Aborted.\n", font_name);
    exit(1);
  }
/*do
  {
    printf("enter font name (no .snf.Z suffix): ");
    scanf("%[^\n]", font_name);
    getchar();
    font_struct = XLoadQueryFont(display, font_name);
  }
while (font_struct == NULL);*/

printf("using font %s\n", font_name);
font_list = XmFontListCreate(font_struct, CharSet);

/******* text *******/
if (argc > 1)
  {
    fp = fopen(argv[1], "r");
    if (fp == NULL)
      {
	fprintf(stderr, "ERROR: Unable to open input message file. Aborted\n");
	exit(1);
      }
    fscanf(fp, "%[^\n]", msg_buf);
    getc(fp);
    i = fscanf(fp, "%[^\n]", buf);
    getc(fp);
    while (i != EOF)
      {
	strcat(msg_buf, "\n");
	strcat(msg_buf, buf);
	buf[0] = '\0';
	i = fscanf(fp, "%[^\n]", buf);
	getc(fp);
      }
    fclose(fp);
  }
else
  {
    printf("enter message (end with a blank line): ");
    scanf("%[^\n]", msg_buf);
    getchar();
    scanf("%[^\n]", buf);
    getchar();
    while (strlen(buf) > 0)
      {
	strcat(msg_buf, "\n");
	strcat(msg_buf, buf);
	buf[0] = '\0';
	scanf("%[^\n]", buf);
	getchar();
      }
  }
message = XmStringCreateLtoR(msg_buf, CharSet);

/********* label ********/
nargs = 0;
XtSetArg(args[nargs], XmNlabelString, message); ++nargs;
XtSetArg(args[nargs], XmNfontList, font_list); ++nargs;
XtSetArg(args[nargs], XmNmarginTop, 10); ++nargs;
XtSetArg(args[nargs], XmNmarginLeft, 20); ++nargs;
XtSetArg(args[nargs], XmNmarginRight, 20); ++nargs;
main_label = XmCreateLabel(app_shell, "label", args, nargs);
XtManageChild(main_label);

XtRealizeWidget(app_shell);
/*XtAppAddTimeOut(theAppContext, 5000, memo_exit, NULL);*/
XtAppMainLoop(theAppContext);
}

/********************/
void memo_exit(w, client_data, call_data)
     Widget
       w;
     caddr_t
       client_data,
       call_data;
{
exit(0);
}
